# coding: utf-8

"""
    VMware Aria Automation Assembler / Service Broker API

    A multi-cloud API for Cloud Automation Services  The APIs that list collections of resources also support OData like implementation. Below query params can be used across Assembler / Service Broker entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/catalog/api/items?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/catalog/api/items?$top=10&$skip=2```  3. `page` and `size` - page used in conjunction with `$size` helps in pagination of resources.      ```/catalog/api/items?page=0&size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /catalog/api/items?$filter=startswith(name, 'Act')     /catalog/api/items?$filter=toupper(name) eq 'ACTIVATE'     /catalog/api/items?$filter=substringof('renameVM', name)     /catalog/api/items?$filter=name eq 'ABCD'  # noqa: E501

    OpenAPI spec version: 2020-08-25
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class Notification(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'scenario_id': 'str',
        'data': 'object',
        'recipients': 'list[str]',
        'group_recipients': 'list[str]',
        'created_at': 'datetime',
        'created_by': 'str',
        'last_updated_at': 'datetime',
        'last_updated_by': 'str'
    }

    attribute_map = {
        'id': 'id',
        'scenario_id': 'scenarioId',
        'data': 'data',
        'recipients': 'recipients',
        'group_recipients': 'groupRecipients',
        'created_at': 'createdAt',
        'created_by': 'createdBy',
        'last_updated_at': 'lastUpdatedAt',
        'last_updated_by': 'lastUpdatedBy'
    }

    def __init__(self, id=None, scenario_id=None, data=None, recipients=None, group_recipients=None, created_at=None, created_by=None, last_updated_at=None, last_updated_by=None):  # noqa: E501
        """Notification - a model defined in Swagger"""  # noqa: E501
        self._id = None
        self._scenario_id = None
        self._data = None
        self._recipients = None
        self._group_recipients = None
        self._created_at = None
        self._created_by = None
        self._last_updated_at = None
        self._last_updated_by = None
        self.discriminator = None
        if id is not None:
            self.id = id
        self.scenario_id = scenario_id
        if data is not None:
            self.data = data
        if recipients is not None:
            self.recipients = recipients
        if group_recipients is not None:
            self.group_recipients = group_recipients
        if created_at is not None:
            self.created_at = created_at
        if created_by is not None:
            self.created_by = created_by
        if last_updated_at is not None:
            self.last_updated_at = last_updated_at
        if last_updated_by is not None:
            self.last_updated_by = last_updated_by

    @property
    def id(self):
        """Gets the id of this Notification.  # noqa: E501

        Notification id  # noqa: E501

        :return: The id of this Notification.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Notification.

        Notification id  # noqa: E501

        :param id: The id of this Notification.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def scenario_id(self):
        """Gets the scenario_id of this Notification.  # noqa: E501

        Notification scenario id  # noqa: E501

        :return: The scenario_id of this Notification.  # noqa: E501
        :rtype: str
        """
        return self._scenario_id

    @scenario_id.setter
    def scenario_id(self, scenario_id):
        """Sets the scenario_id of this Notification.

        Notification scenario id  # noqa: E501

        :param scenario_id: The scenario_id of this Notification.  # noqa: E501
        :type: str
        """
        if scenario_id is None:
            raise ValueError("Invalid value for `scenario_id`, must not be `None`")  # noqa: E501

        self._scenario_id = scenario_id

    @property
    def data(self):
        """Gets the data of this Notification.  # noqa: E501


        :return: The data of this Notification.  # noqa: E501
        :rtype: object
        """
        return self._data

    @data.setter
    def data(self, data):
        """Sets the data of this Notification.


        :param data: The data of this Notification.  # noqa: E501
        :type: object
        """

        self._data = data

    @property
    def recipients(self):
        """Gets the recipients of this Notification.  # noqa: E501

        List of recipients (max 100 recipients)  # noqa: E501

        :return: The recipients of this Notification.  # noqa: E501
        :rtype: list[str]
        """
        return self._recipients

    @recipients.setter
    def recipients(self, recipients):
        """Sets the recipients of this Notification.

        List of recipients (max 100 recipients)  # noqa: E501

        :param recipients: The recipients of this Notification.  # noqa: E501
        :type: list[str]
        """

        self._recipients = recipients

    @property
    def group_recipients(self):
        """Gets the group_recipients of this Notification.  # noqa: E501

        List of group recipients (max 10 groups, max 500 users/group will receive the notification)  # noqa: E501

        :return: The group_recipients of this Notification.  # noqa: E501
        :rtype: list[str]
        """
        return self._group_recipients

    @group_recipients.setter
    def group_recipients(self, group_recipients):
        """Sets the group_recipients of this Notification.

        List of group recipients (max 10 groups, max 500 users/group will receive the notification)  # noqa: E501

        :param group_recipients: The group_recipients of this Notification.  # noqa: E501
        :type: list[str]
        """

        self._group_recipients = group_recipients

    @property
    def created_at(self):
        """Gets the created_at of this Notification.  # noqa: E501

        Creation time  # noqa: E501

        :return: The created_at of this Notification.  # noqa: E501
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this Notification.

        Creation time  # noqa: E501

        :param created_at: The created_at of this Notification.  # noqa: E501
        :type: datetime
        """

        self._created_at = created_at

    @property
    def created_by(self):
        """Gets the created_by of this Notification.  # noqa: E501

        Created By  # noqa: E501

        :return: The created_by of this Notification.  # noqa: E501
        :rtype: str
        """
        return self._created_by

    @created_by.setter
    def created_by(self, created_by):
        """Sets the created_by of this Notification.

        Created By  # noqa: E501

        :param created_by: The created_by of this Notification.  # noqa: E501
        :type: str
        """

        self._created_by = created_by

    @property
    def last_updated_at(self):
        """Gets the last_updated_at of this Notification.  # noqa: E501

        Update time  # noqa: E501

        :return: The last_updated_at of this Notification.  # noqa: E501
        :rtype: datetime
        """
        return self._last_updated_at

    @last_updated_at.setter
    def last_updated_at(self, last_updated_at):
        """Sets the last_updated_at of this Notification.

        Update time  # noqa: E501

        :param last_updated_at: The last_updated_at of this Notification.  # noqa: E501
        :type: datetime
        """

        self._last_updated_at = last_updated_at

    @property
    def last_updated_by(self):
        """Gets the last_updated_by of this Notification.  # noqa: E501

        Updated By  # noqa: E501

        :return: The last_updated_by of this Notification.  # noqa: E501
        :rtype: str
        """
        return self._last_updated_by

    @last_updated_by.setter
    def last_updated_by(self, last_updated_by):
        """Sets the last_updated_by of this Notification.

        Updated By  # noqa: E501

        :param last_updated_by: The last_updated_by of this Notification.  # noqa: E501
        :type: str
        """

        self._last_updated_by = last_updated_by

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Notification, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Notification):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
